package de.w665.fluidcms.model;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import de.w665.fluidcms.model.objectattributes.StringObjectAttribute;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Setter
@Getter
@AllArgsConstructor
@NoArgsConstructor
@JsonTypeInfo(
        use = JsonTypeInfo.Id.NAME,
        property = "type")
@JsonSubTypes({
        @JsonSubTypes.Type(value = StringObjectAttribute.class, name = "String"),
})
public abstract class ObjectAttribute <T> {
    private String name;
    private String description;
    private boolean required;
    private T defaultValue;

    public abstract String getValueAsString();
    public abstract T getValue();
    public abstract void setValue(T value);
}
